//  LauncherOSX
//
//  Created by Boris Schneiderman.
//  Copyright (c) 2012-2013 The Readium Foundation.
//
//  The Readium SDK is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

//This is demo file that does nothing
//Host application has to override this file and provide it's own logic for handling ReadiumSDK events
//See LauncherOSX and LauncherIOS for examples
ReadiumSDK.HostAppFeedback = function() {

    ReadiumSDK.on(ReadiumSDK.Events.READER_INITIALIZED, function(){

        window.navigator.epubReadingSystem.name = "Launcher-Android";
        window.navigator.epubReadingSystem.version = "0.0.1";

        ReadiumSDK.reader.on(ReadiumSDK.Events.PAGINATION_CHANGED, this.onPaginationChanged, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.SETTINGS_APPLIED, this.onSettingsApplied, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.CONTENT_DOCUMENT_LOAD_START, this.onContentLoading, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.CONTENT_DOCUMENT_LOADED, this.onContentLoaded, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.CONTENT_DOCUMENT_LOAD_FAILED, this.onContentLoadFailed, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.MEDIA_OVERLAY_STATUS_CHANGED, this.onMediaOverlayStatusChanged, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.MEDIA_OVERLAY_TTS_SPEAK, this.onMediaOverlayTTSSpeak, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.MEDIA_OVERLAY_TTS_STOP, this.onMediaOverlayTTSStop, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.IMAGE_CLICKED, this.onImageClicked, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.AUDIO_CLICKED, this.onAudioClicked, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.VIDEO_CLICKED, this.onVideoClicked, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.EXERCISE_CLICKED, this.onExerciseClicked, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.SELECTION_CHANGED, this.onSelectionChanged, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.TAP_LEFT, this.onTapLeft, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.TAP_RIGHT, this.onTapRight, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.TAP_RIGHT_LAST, this.onTapRightLast, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.TAP_CENTER, this.onTapCenter, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.DRAW_HIGHLIGHTS, this.drawHighlights, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.GET_NOTE_DATA, this.getNoteData, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.HIGHLIGHT_CLICKED, this.onHighlightClicked, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.CHECK_BOOKMARKS, this.checkBookmarks, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.REMOVE_BOOKMARKS, this.removeBookmarks, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.TAP_HOLD, this.onTapHold, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.DRAW_SELECTION, this.drawSelection, this);
        ReadiumSDK.reader.on(ReadiumSDK.Events.UPDATE_PAGINATION, this.updatePagination, this);

        window.LauncherUI.onReaderInitialized();

    }, this);

    this.onPaginationChanged = function(paginationInfo) {

        if (window.LauncherUI && window.LauncherUI.onPaginationChanged) {
            window.LauncherUI.onPaginationChanged(JSON.stringify(paginationInfo.paginationInfo));

            if(window.LauncherUI.onIsMediaOverlayAvailable){
                window.LauncherUI.onIsMediaOverlayAvailable(ReadiumSDK.reader.isMediaOverlayAvailable());
            }
        }

    };

    this.onSettingsApplied = function() {

        if(window.LauncherUI && window.LauncherUI.onSettingsApplied) {
            window.LauncherUI.onSettingsApplied();
        }
    };
    
    this.onContentLoading = function() {

        if(window.LauncherUI && window.LauncherUI.onContentLoading) {
            window.LauncherUI.onContentLoading();
        }
    };

    this.onContentLoaded = function() {

        if(window.LauncherUI && window.LauncherUI.onContentLoaded) {
            window.LauncherUI.onContentLoaded();
        }
    };
    
    this.onContentLoadFailed = function() {

        if(window.LauncherUI && window.LauncherUI.onContentLoadFailed) {
            window.LauncherUI.onContentLoadFailed();
        }
    };

    this.onMediaOverlayStatusChanged = function(status) {

        if(window.LauncherUI && window.LauncherUI.onMediaOverlayStatusChanged) {
            window.LauncherUI.onMediaOverlayStatusChanged(JSON.stringify(status));
        }
    };

    this.onMediaOverlayTTSSpeak = function(tts) {

        if(window.LauncherUI && window.LauncherUI.onMediaOverlayTTSSpeak) {
            window.LauncherUI.onMediaOverlayTTSSpeak(JSON.stringify(tts));
        }
    };

    this.onMediaOverlayTTSStop = function() {

        if(window.LauncherUI && window.LauncherUI.onMediaOverlayTTSStop) {
            window.LauncherUI.onMediaOverlayTTSStop();
        }
    };
    
    this.onImageClicked = function(image) {
        if(window.LauncherUI && window.LauncherUI.onImageClicked) {
            window.LauncherUI.onImageClicked(image.src, image.left, image.top, image.width, image.height, image.doubleTap);
        }
    };
    
    this.onAudioClicked = function(audio) {
        if(window.LauncherUI && window.LauncherUI.onAudioClicked) {
            window.LauncherUI.onAudioClicked(audio.id, audio.name, audio.left, audio.top, audio.width, audio.height, audio.doubleTap);
        }
    };
    
    this.onVideoClicked = function(video) {
        if(window.LauncherUI && window.LauncherUI.onVideoClicked) {
            window.LauncherUI.onVideoClicked(video.id, video.name, video.left, video.top, video.width, video.height, video.doubleTap);
        }
    };
    
    this.onExerciseClicked = function(exercise) {
        if(window.LauncherUI && window.LauncherUI.onExerciseClicked) {
            window.LauncherUI.onExerciseClicked(exercise.knowledge, exercise.exclude, exercise.count, exercise.doubleTap);
        }
    };
    
    this.onSelectionChanged = function(text, handleBounds) {
        if(window.LauncherUI && window.LauncherUI.onSelectionChanged) {
            window.LauncherUI.onSelectionChanged(text, handleBounds.left, handleBounds.top, handleBounds.right, handleBounds.bottom);
        }
    };
    
    this.onTapLeft = function() {
        if(window.LauncherUI && window.LauncherUI.onTapLeft) {
            window.LauncherUI.onTapLeft();
        }
    };
    
    this.onTapRight = function() {
        if(window.LauncherUI && window.LauncherUI.onTapRight) {
            window.LauncherUI.onTapRight();
        }
    };
    
    this.onTapRightLast = function() {
        if(window.LauncherUI && window.LauncherUI.onTapRightLast) {
            window.LauncherUI.onTapRightLast();
        }
    };
    
    this.onTapCenter = function() {
        if(window.LauncherUI && window.LauncherUI.onTapCenter) {
            window.LauncherUI.onTapCenter();
        }
    };

    this.drawHighlights = function(highlights) {
        if(window.LauncherUI && window.LauncherUI.drawHighlights) {
            window.LauncherUI.drawHighlights(JSON.stringify(highlights));
        }
    };

    this.getNoteData = function(note) {
        if(window.LauncherUI && window.LauncherUI.getNoteData) {
            window.LauncherUI.getNoteData(JSON.stringify(note));
        }
    };
    
    this.onHighlightClicked = function(highlight) {
        if(window.LauncherUI && window.LauncherUI.onHighlightClicked) {
            window.LauncherUI.onHighlightClicked(highlight.timestamp, highlight.left, highlight.top, highlight.width, highlight.height);
        }
    };
    
    this.checkBookmarks = function(bookmarked) {
        if(window.LauncherUI && window.LauncherUI.checkBookmarks) {
            window.LauncherUI.checkBookmarks(bookmarked);
        }
    };
    
    this.removeBookmarks = function(bookmarks) {
        if(window.LauncherUI && window.LauncherUI.removeBookmarks) {
            window.LauncherUI.removeBookmarks(JSON.stringify(bookmarks));
        }
    };

    this.onTapHold = function() {
        if(window.LauncherUI && window.LauncherUI.onTapHold) {
            window.LauncherUI.onTapHold();
        }
    };

    this.drawSelection = function(selection) {
        if(window.LauncherUI && window.LauncherUI.drawSelection) {
            window.LauncherUI.drawSelection(JSON.stringify(selection));
        }
    };

    this.updatePagination = function(paginationInfo) {
        if (window.LauncherUI && window.LauncherUI.updatePagination) {
            window.LauncherUI.updatePagination(JSON.stringify(paginationInfo.paginationInfo));
        }
    };

}();

